// ܺA NetworkType (Microsoft Terminal Services, Microsoft Windows Network, Web Client Network)
// ܤu@s WorkGroup Name (Ҧp Microsoft Windows Network  WorkGroup, WorkGroup2)
// ܹqW Computer Name (Ҧp WorkGroup  Tony, Peter)
// ܹqɪؿ
// }ou Delphi 7 Enterprise
// Ref :
//   http://www.infojet.cz/program/delphi/tips/tip0012.html
// 2007/11/22

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    procedure FormCreate(Sender: TObject);
    function FindComputers: DWORD;
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  Computers: TStringList;
const
  MaxEntries = 250;



implementation

{$R *.dfm}

function TForm1.FindComputers: DWORD;

var
  EnumWorkGroupHandle, 
  EnumComputerHandle  : THandle;
  EnumPCHandle        : THandle;
  EnumDirHandle        : THandle;
  EnumError           : DWORD;
  Network             : TNetResource;
  WorkGroupEntries,
  ComputerEntries     : DWORD;
  PCEntries     : DWORD;
  DirEntries     : DWORD;
  EnumWorkGroupBuffer,
  EnumComputerBuffer : array[1..MaxEntries] of TNetResource;
  EnumPCBuffer : array[1..MaxEntries] of TNetResource;
  EnumDirBuffer : array[1..MaxEntries] of TNetResource;
  EnumBufferLength    : DWORD;
  I, J, K, L                : DWORD;

begin

  Computers.Clear;

  FillChar(Network, SizeOf(Network), 0);
  with Network do
  begin
    dwScope := RESOURCE_GLOBALNET;
    dwType := RESOURCETYPE_ANY;
    dwUsage := RESOURCEUSAGE_CONTAINER;
  end;

  EnumError := WNetOpenEnum(RESOURCE_GLOBALNET,
                            RESOURCETYPE_ANY, 0,
                            @Network,
                            EnumWorkGroupHandle);

  if EnumError = NO_ERROR then
  begin
    WorkGroupEntries := MaxEntries;
    EnumBufferLength := SizeOf(EnumWorkGroupBuffer);
    EnumError := WNetEnumResource(EnumWorkGroupHandle,
                                 WorkGroupEntries,
                                 @EnumWorkGroupBuffer,
                                 EnumBufferLength);

    if EnumError = NO_ERROR then
    begin
      for I := 1 to WorkGroupEntries do
      begin
        Memo1.Lines.Add(EnumWorkGroupBuffer[I].lpProvider);
        EnumError := WNetOpenEnum(RESOURCE_GLOBALNET,
                                RESOURCETYPE_ANY, 0,
                                @EnumWorkGroupBuffer[I],
                                EnumComputerHandle);
        if EnumError = NO_ERROR then
        begin
          ComputerEntries := MaxEntries;
          EnumBufferLength:= SizeOf(EnumComputerBuffer);
          EnumError:=WNetEnumResource(EnumComputerHandle,
                                    ComputerEntries,
                                    @EnumComputerBuffer,
                                    EnumBufferLength);

          if EnumError = NO_ERROR then
            for J := 1 to ComputerEntries do
            begin
              Computers.Add(Copy(EnumComputerBuffer[J].
                lpRemoteName, 3, Length(EnumComputerBuffer[J].
                lpRemoteName) - 2));
              Memo1.Lines.Add(EnumComputerBuffer[J].lpRemoteName);

              //-----------------
              EnumError := WNetOpenEnum(RESOURCE_GLOBALNET,
                                RESOURCETYPE_ANY, 0,
                                @EnumComputerBuffer[J],
                                EnumPCHandle);
              if EnumError = NO_ERROR then
              begin
                PCEntries := MaxEntries;
                EnumBufferLength:= SizeOf(EnumPCBuffer);
                EnumError:=WNetEnumResource(EnumPCHandle,
                                    PCEntries,
                                    @EnumPCBuffer,
                                    EnumBufferLength);

                if EnumError = NO_ERROR then
                  for K := 1 to PCEntries do
                  begin
                  {
                    Computers.Add(Copy(EnumComputerBuffer[J].
                     lpRemoteName, 3, Length(EnumComputerBuffer[J].
                     lpRemoteName) - 2));
                   }
                    Memo1.Lines.Add(EnumPCBuffer[K].lpRemoteName);

                    // *********************************************
                    EnumError := WNetOpenEnum(RESOURCE_GLOBALNET,
                                RESOURCETYPE_ANY, 0,
                                @EnumPCBuffer[K],
                                EnumDirHandle);
                    if EnumError = NO_ERROR then
                    begin
                      DirEntries := MaxEntries;
                      EnumBufferLength:= SizeOf(EnumDirBuffer);
                      EnumError:=WNetEnumResource(EnumDirHandle,
                                    DirEntries,
                                    @EnumDirBuffer,
                                    EnumBufferLength);

                      if EnumError = NO_ERROR then
                        for L := 1 to DirEntries do
                        begin
                        {
                          Computers.Add(Copy(EnumComputerBuffer[J].
                           lpRemoteName, 3, Length(EnumComputerBuffer[J].
                           lpRemoteName) - 2));
                         }
                          Memo1.Lines.Add(EnumDirBuffer[L].lpRemoteName);
                        end;
                    end;
                    // *********************************************

                  end;
              end;
              //--------------

            end;
          WNetCloseEnum(EnumComputerHandle);
        end;
      end;
    end;
    WNetCloseEnum(EnumWorkGroupHandle);
  end;

  if EnumError = ERROR_NO_MORE_ITEMS then
    EnumError := NO_ERROR;
  Result := EnumError;

end;

procedure TForm1.FormCreate(Sender: TObject);
var
  i: Integer;
begin
  Memo1.Clear;
  Computers := TStringList.Create;
  FindComputers;
  {
  for i:=0 to Computers.Count -1 do
  begin
    Memo1.Lines.Add(Computers.Strings[i]);
  end;
  }
  Memo1.Lines.Add('Finish!');
  Computers.Free;

end;

end.
